//28 30 a084
#include <stdio.h>
#include <allegro.h>

int paldirty[256];
void dumpspr();
unsigned char mosaic,mosaicen;
int skipbne;
int inhdma=0;
int instructions;
unsigned char opcode;
int logsta;
int spuskip;
int spuskippos=0;
unsigned short d;
int checkf000;
int screenon;
int rotozoom;
int hdmaena;
unsigned char extbgenable=0;
int dmaout;
int palf;
int first3d=1;
int v_line,latchedvline;
int hdmacount[8],hdmarepeat[8],hdmafirst[8];
unsigned short hdmaaddr[8];
unsigned char hdmabank[8];
unsigned char hdmadata[8][4];
unsigned char dmactrl[8],dmadest[8],dmabank[8];
unsigned long dmasrc[8],dmasize[8];
unsigned char hdmaon=0;
int xs[4][224],ys[4][224];
unsigned char ppumodel[224],bgenablel[224];
unsigned short bgs[4][224],chs[4][224];
unsigned long tiles[4][1024][16];

unsigned short m7a,m7b,m7c,m7d,m7x,m7y;
unsigned short m7al[224],m7bl[224],m7cl[224],m7dl[224],m7xl[224],m7yl[224];
int m7change[224];
int m7write=0;
unsigned char m7sel;

unsigned char activechan;
int sprswap;
int videoon=0;
int dmaout;
int fps,frames;
int spuout;
int vertcomp;
int intenable;

typedef union
{
        unsigned short w;
        struct
        {
                unsigned char l,h;
        } b;
} sreg;

sreg a,x,y,s;

unsigned char pbr;
unsigned short pc;

int cycles,oldcycles;

BITMAP *b;
PALETTE pal;

void highcol()
{
        pal[0].r=63;
        set_color(0,&pal[0]);
}

unsigned char fliptable[256];
unsigned long bittable[2][16],masktable[2][16],coltable[8];

unsigned long wramaddr;

int objsize[4];
int objsizes[16][2]={ {1,1}, {2,2}, {1,1}, {4,4}, {1,1}, {8,8}, {2,2}, {4,4}, {2,2}, {8,8}, {4,4}, {8,8} };

unsigned char *vram;
void takescreenshot()
{
        save_pcx("scrshot.pcx",b,pal);
}

void initvideo()
{
        int c;
        videoon=1;
        set_gfx_mode(GFX_AUTODETECT,320,240,0,0);
        b=create_bitmap(512,512);
        for (c=0;c<16;c++)
        {
                bittable[0][c]=0;
                if (c&0x8) bittable[0][c]|=0x00000001;
                if (c&0x4) bittable[0][c]|=0x00000100;
                if (c&0x2) bittable[0][c]|=0x00010000;
                if (c&0x1) bittable[0][c]|=0x01000000;
                bittable[1][c]=0;
                if (c&0x1) bittable[1][c]|=0x00000001;
                if (c&0x2) bittable[1][c]|=0x00000100;
                if (c&0x4) bittable[1][c]|=0x00010000;
                if (c&0x8) bittable[1][c]|=0x01000000;
                masktable[0][c]=0;
                if (c&0x8) masktable[0][c]|=0x000000FF;
                if (c&0x4) masktable[0][c]|=0x0000FF00;
                if (c&0x2) masktable[0][c]|=0x00FF0000;
                if (c&0x1) masktable[0][c]|=0xFF000000;
                masktable[1][c]=0;
                if (c&0x1) masktable[1][c]|=0x000000FF;
                if (c&0x2) masktable[1][c]|=0x0000FF00;
                if (c&0x4) masktable[1][c]|=0x00FF0000;
                if (c&0x8) masktable[1][c]|=0xFF000000;
        }
        for (c=0;c<256;c++)
        {
                fliptable[c]=0;
                if (c&0x01) fliptable[c]|=0x80;
                if (c&0x02) fliptable[c]|=0x40;
                if (c&0x04) fliptable[c]|=0x20;
                if (c&0x08) fliptable[c]|=0x10;
                if (c&0x10) fliptable[c]|=0x08;
                if (c&0x20) fliptable[c]|=0x04;
                if (c&0x40) fliptable[c]|=0x02;
                if (c&0x80) fliptable[c]|=0x01;
        }
        coltable[0]=0;
        coltable[1]=0x01010101;
        coltable[2]=0x02020202;
        coltable[3]=0x03030303;
        coltable[4]=0x04040404;
        coltable[5]=0x05050505;
        coltable[6]=0x06060606;
        coltable[7]=0x07070707;
        vram=malloc(65536);
        atexit(dumpspr);
}

unsigned char ram[0x20000];
unsigned char vramctrl;
unsigned long vramaddr;

unsigned char objram[1024];
unsigned short objaddr;

void swapsprite()
{
        sprswap^=1;
}

void closevideo()
{
        FILE *f=fopen("vram.dmp","wb");
        fwrite(vram,0x10000,1,f);
        fwrite(objram,0x400,1,f);
        fclose(f);
        destroy_bitmap(b);
        free(vram);
}

int ppumode;

int tilesize;
int vraminc;
int vramrate[4]={1,32,128,256};
int firstread=1;
unsigned short bgaddr[4],chraddr[4];
unsigned short sprchraddr;
int xscroll[4],yscroll[4];
int bgsize[4];

unsigned char cgram[512];
unsigned short cgramaddr;

int firstobjwrite=1;

int bg3pri;
unsigned char bgenable,mainbg,subbg;

unsigned short matrixa,matrixb;
unsigned long matrixr;

void dumpppuregs()
{
        printf("BGEN %01X %i %04X %04X %04X %04X\n",bgenable&0xF,bg3pri,bgaddr[0],bgaddr[1],bgaddr[2],bgaddr[3]);
        printf("%04X %04X %04X %04X\n",chraddr[0],chraddr[1],chraddr[2],chraddr[3]);
        printf("INTENA %02X  vertcomp %i\n",intenable,vertcomp);
        printf("mode %i\n",ppumode);
        printf("OBJ size %i %i %i %i\n",objsize[0],objsize[1],objsize[2],objsize[3]);
        printf("HDMA enable %02X\n",hdmaon);
}

void dumpvram()
{
        FILE *f=fopen("vram.dmp","wb");
        fwrite(vram,65536,1,f);
        putc(bgaddr[0]>>8,f); putc(bgaddr[0]&0xFF,f);
        putc(bgaddr[1]>>8,f); putc(bgaddr[1]&0xFF,f);        
        putc(bgsize[0],f); putc(bgsize[1],f);
        putc(yscroll[0]>>8,f); putc(yscroll[0]&0xFF,f);
        putc(yscroll[1]>>8,f); putc(yscroll[1]&0xFF,f);        
        fclose(f);
}

void updatebgen()
{
        bgenable=((mainbg|subbg)^extbgenable);
}

void writeppu(unsigned short addr, unsigned char val)
{
        unsigned short tempw;
        switch (addr&0xFF)
        {
                case 0:
                screenon=!(val&0x80);
//                pal[0].r=pal[0].g=pal[0].b=(val&0xF)<<2;
//                set_color(0,&pal[0]);
                break;
                case 0x01:
//                printf("$2001 write %02X %02X:%04X\n",val,pbr,pc);
//                val|=3;
                sprchraddr=(val&3)<<14;
                val>>=5;
                val<<=1;
                objsize[0]=objsizes[val][0];
                objsize[1]=objsizes[val][1];
                objsize[2]=objsizes[val+1][0];
                objsize[3]=objsizes[val+1][1];
                break;
                case 0x02:
                objaddr&=0x100;
                objaddr|=val;
                break;
                case 0x03:
                if (val&1)
                   objaddr|=0x100;
                else
                   objaddr&=0xFE;
                firstobjwrite=1;
                break;
                case 0x04:
//                if (!objaddr) printf("OBJ writing at %02X:%04X\n",pbr,pc);
//                objaddr&=0x1FF;
                if (objaddr>0x10F) { objaddr=0; firstobjwrite=1; }
//                if ((objaddr<<1)==0x124) printf("OBJ write 124 %02X %02X:%04X\n",val,pbr,pc);
                if (firstobjwrite)
                   objram[objaddr<<1]=val;
                else
                {
                        objram[(objaddr<<1)+1]=val;
                        objaddr++;
                }
                firstobjwrite^=1;
                break;
                case 0x05:
                ppumode=val&7;
//                printf("Now mode %i\n",ppumode);
                bg3pri=val&8;
                tilesize=val>>4;
                break;
                case 0x06:
                mosaic=val&0xF;
                mosaicen=val>>4;
                break;
                case 0x07:
                bgaddr[0]=(val&0x7C)<<9;
                bgsize[0]=val&3;
//                if (checkf000 && bgaddr[0]==0xE000) printf("Change to E000 %02X:%04X %04X\n",pbr,pc,d);
                break;
                case 0x08:
                bgaddr[1]=(val&0x7C)<<9;
                bgsize[1]=val&3;
                break;
                case 0x09:
                bgaddr[2]=(val&0x7C)<<9;
                bgsize[2]=val&3;
                break;
                case 0x0B:
                chraddr[0]=(val&0x7)<<13;
                chraddr[1]=(val>>4)<<13;
                break;
                case 0x0C:
                chraddr[2]=(val&0x7)<<13;
                chraddr[3]=(val>>4)<<13;
                break;
                case 0x0D:
                xscroll[0]>>=8;
                xscroll[0]|=(val<<8);
//                printf("Xscroll write %02X now %04X\n",val,xscroll[0]);
                break;
                case 0x0E:
                yscroll[0]>>=8;
                yscroll[0]|=(val<<8);
//                printf("Yscroll write %02X now %04X\n",val,yscroll[0]);
                break;
                case 0x0F:
                xscroll[1]>>=8;
                xscroll[1]|=(val<<8);
                break;
                case 0x10:
                yscroll[1]>>=8;
                yscroll[1]|=(val<<8);
                break;
                case 0x11:
                xscroll[2]>>=8;
                xscroll[2]|=(val<<8);
                break;
                case 0x12:
                yscroll[2]>>=8;
                yscroll[2]|=(val<<8);
                break;
                case 0x15:
//                printf("2115 %02X\n",val);
                vramctrl=val;
                vraminc=vramrate[val&3];
                break;
                case 0x16:
                firstread=1;
                vramaddr&=0xFF00;
                vramaddr|=val&0xFF;
//                if (dmaout) printf("2116 VRAM addr %05X %04X\n",vramaddr<<1,a.w);
                break;
                case 0x17:
                firstread=1;
                vramaddr&=0xFF;
                vramaddr|=val<<8;
//                printf("2117 VRAM addr %05X %02X:%04X\n",vramaddr<<1,pbr,pc);
                break;
                case 0x18:
                firstread=1;
//                if (dmaout)
//                   printf("%04X write %02X %02X:%04X\n",(vramaddr<<1)&0xFFFF,val,pbr,pc);
//                if (!vramaddr) printf("2118 %02X %02X:%04X %04X %04X %02X\n",val,pbr,pc,d,x.w,opcode);
//                if (!vramaddr) logsta=1;
//                if ((vramaddr<<1)==0x3180) printf("VRAM WRITE %02X:%04X %04X %04X %02X %02X\n",pbr,pc,d,x.w,opcode,val);
//                if (((vramaddr<<1)&0xE000)==chraddr[2])
                
                vram[(vramaddr<<1)&0xFFFF]=val;
                if (!(vramctrl&0x80))
                   vramaddr+=vraminc;
                break;
                case 0x19:
                firstread=1;
//                if (dmaout)
//                   printf("%04X write %02X %02X:%04X\n",((vramaddr<<1)+1)&0xFFFF,val,pbr,pc);
//                if ((vramaddr<<1)==0xF000) printf("F001 write %02X at %02X:%04X\n",val,pbr,pc);
                vram[((vramaddr<<1)+1)&0xFFFF]=val;
                if (vramctrl&0x80)
                   vramaddr+=vraminc;
                break;
                case 0x1A:
                m7sel=val;
                break;
                case 0x1B:
//                printf("PC %02X:%04X %02X %04X\n",pbr,pc,val,d);
                m7a=(m7a>>8)|(val<<8);
                matrixr=(short)m7a*((short)m7b>>8);
//                printf("%04Xx%02X\n",m7a,m7b>>8);
                break;
                case 0x1C:
                m7b=(m7b>>8)|(val<<8);
                matrixr=(short)m7a*((short)m7b>>8);
                m7write=1;
//                printf("%04Xx%02X\n",m7a,m7b>>8);
                break;
                case 0x1D:
                m7c=(m7c>>8)|(val<<8);
                break;
                case 0x1E:
                m7d=(m7d>>8)|(val<<8);
                m7write=1;
                break;
                case 0x1F:
                m7x=(m7x>>8)|(val<<8);
                break;
                case 0x20:
                m7y=(m7y>>8)|(val<<8);
                break;
                case 0x21:
                cgramaddr=val<<1;
                break;
                case 0x22:
//                if (!cgramaddr) printf("CGRAM write at %02X:%04X %i\n",pbr,pc,instructions);
                cgram[cgramaddr&0x1FF]=val;
                tempw=cgram[cgramaddr&0x1FE]|(cgram[(cgramaddr&0x1FE)+1]<<8);
                pal[cgramaddr>>1].r=(tempw&31)<<1;
                pal[cgramaddr>>1].g=((tempw>>5)&31)<<1;
                pal[cgramaddr>>1].b=((tempw>>10)&31)<<1;
                if (videoon && !inhdma)
                   paldirty[cgramaddr>>1]=1;
//                   set_color((cgramaddr>>1)&0xFF,&pal[cgramaddr>>1]);
                cgramaddr++;
                break;
                case 0x2C:
                mainbg=val;
                bgenable=((mainbg|subbg)^extbgenable);//|subbg;
                break;
                case 0x2D:
                subbg=val;
                bgenable=((mainbg|subbg)^extbgenable);//|subbg;
                break;

                case 0x40: case 0x41: case 0x42: case 0x43: case 0x44: case 0x45: case 0x46: case 0x47:
                case 0x48: case 0x49: case 0x4A: case 0x4B: case 0x4C: case 0x4D: case 0x4E: case 0x4F:
                case 0x50: case 0x51: case 0x52: case 0x53: case 0x54: case 0x55: case 0x56: case 0x57:
                case 0x58: case 0x59: case 0x5A: case 0x5B: case 0x5C: case 0x5D: case 0x5E: case 0x5F:
                case 0x60: case 0x61: case 0x62: case 0x63: case 0x64: case 0x65: case 0x66: case 0x67:
                case 0x68: case 0x69: case 0x6A: case 0x6B: case 0x6C: case 0x6D: case 0x6E: case 0x6F:
                case 0x70: case 0x71: case 0x72: case 0x73: case 0x74: case 0x75: case 0x76: case 0x77:
                case 0x78: case 0x79: case 0x7A: case 0x7B: case 0x7C: case 0x7D: case 0x7E: case 0x7F:
//                printf("SPU write\n");
//                dumpregs();
//                exit(-1);
                writespuport(addr,val);                
                break;

                case 0x80:
                ram[wramaddr++]=val;
                wramaddr&=0x1FFFF;
                break;
                case 0x81:
                wramaddr=(wramaddr&0x1FF00)|val;
                break;
                case 0x82:
                wramaddr=(wramaddr&0x100FF)|(val<<8);
                break;
                case 0x83:
                wramaddr=(wramaddr&0xFFFF)|((val&1)<<16);
                break;
        }
}

int spuskiptemp=0;
unsigned char spuram[65536];

unsigned char spuskipper(unsigned short addr)
{
        switch (addr&0xFF)
        {
                case 0x40: case 0x42:
                oldcycles=cycles;
                spuskippos++;
                if (spuskippos>51) spuskippos=0;
                switch (spuskippos>>1)
                {
                        case 0:
                        return a.b.l;
                        case 1:
                        return x.b.l;
                        case 2:
                        return y.b.l;
                        case 3:
                        return 0x55;
                        case 4:
                        return 0xAA;
                        case 5:
                        return 7;
                        case 6:
                        return 1;
                        case 7:
                        return 0xFF;
                        case 8:
                        return 0xAB;
                        case 9:
                        return 0xBC;
                        case 10:
                        return 0x22;
                        case 11:
                        return 0;
                        case 12:
                        return 0;
                        case 13:
                        return ram[0];
                        case 14:
                        return a.b.h;
                        case 15:
                        return x.b.h;
                        case 16:
                        return y.b.h;
                        case 17:
                        return 0xAA;
                        case 18:
                        return 2;
                        case 19:
                        return 0xCC;
                        case 20:
                        return 1;
                        case 21:
                        return 0xFE;
                        case 22:
                        return 0xC1;
                        case 23:
                        return spuskiptemp++;
                        case 24:
                        return spuram[0xF4];
                        case 25:
                        return spuram[0xF5];
                }
                return 0;

                case 0x41: case 0x43:
                if (cycles!=oldcycles)
                {
                        spuskippos++;
                        if (spuskippos>51) spuskippos=0;
                }
                switch (spuskippos>>1)
                {
                        case 0:
                        return a.b.h;
                        case 1:
                        return x.b.h;
                        case 2:
                        return y.b.h;
                        case 3:
                        return 0xAA;
                        case 4:
                        return 0x55;
                        case 5:
                        return 0;
                        case 6:
                        return 0;
                        case 7:
                        return 0xFF;
                        case 8:
                        return 0xCD;
                        case 9:
                        return 0xBC;
                        case 10:
                        return 0x22;
                        case 11:
                        return 4;
                        case 12:
                        return 4;
                        case 13:
                        return ram[0];
                        case 14:
                        return a.b.l;
                        case 15:
                        return x.b.l;
                        case 16:
                        return y.b.l;
                        case 17:
                        return 0xBB;
                        case 18:
                        return 2;
                        case 19:
                        return 0xCC;
                        case 20:
                        return 1;
                        case 21:
                        return 0xFE;
                        case 22:
                        return 0xC1;
                        case 23:
                        return spuskiptemp++;
                        case 24:
                        return spuram[0xF4];
                        case 25:
                        return spuram[0xF5];
                }
                return 0;
        }
}

unsigned char readppu(unsigned short addr)
{
        unsigned char temp;
        switch (addr&0xFF)
        {
                case 0x34:
                return matrixr;
                case 0x35:
                return matrixr>>8;
                case 0x36:
                return matrixr>>16;

                case 0x37:
                latchedvline=v_line;
                first3d=1;
                return 0;

                case 0x39:
                if (firstread)
                {
                        firstread=0;
                        return vram[(vramaddr<<1)&0xFFFF];
                }
                temp=vram[((vramaddr<<1)-2)&0xFFFF];
                if (!(vramctrl&0x80))
                   vramaddr+=vraminc;
                return temp;

                case 0x3A:
                if (firstread)
                {
                        firstread=0;
                        return vram[((vramaddr<<1)+1)&0xFFFF];
                }
                temp=vram[((vramaddr<<1)-1)&0xFFFF];
                if (vramctrl&0x80)
                   vramaddr+=vraminc;
                return temp;

                case 0x3D:
                if (first3d)
                {
                        first3d=0;
                        return v_line;
                }
                else
                {
                        first3d=1;
                        return v_line>>8;
                }
                break;

                case 0x3F:
                oldcycles=cycles;
                skipbne=0;
//                printf("213F at %02X:%04X\n",pbr,pc);
                if (palf) return 0x10;
                return 0;

                case 0x40: case 0x41: case 0x42: case 0x43: case 0x44: case 0x45: case 0x46: case 0x47:
                case 0x48: case 0x49: case 0x4A: case 0x4B: case 0x4C: case 0x4D: case 0x4E: case 0x4F:
                case 0x50: case 0x51: case 0x52: case 0x53: case 0x54: case 0x55: case 0x56: case 0x57:
                case 0x58: case 0x59: case 0x5A: case 0x5B: case 0x5C: case 0x5D: case 0x5E: case 0x5F:
                case 0x60: case 0x61: case 0x62: case 0x63: case 0x64: case 0x65: case 0x66: case 0x67:
                case 0x68: case 0x69: case 0x6A: case 0x6B: case 0x6C: case 0x6D: case 0x6E: case 0x6F:
                case 0x70: case 0x71: case 0x72: case 0x73: case 0x74: case 0x75: case 0x76: case 0x77:
                case 0x78: case 0x79: case 0x7A: case 0x7B: case 0x7C: case 0x7D: case 0x7E: case 0x7F:                
                if (spuskip)
                {
                        if (cycles!=oldcycles)
                        {
                                skipbne=1;
//                                printf("BNE skip at %02X:%04X\n",pbr,pc);
                        }
                        return spuskipper(addr);
                }
                return readspuport(addr);

                case 0x80:
                return ram[wramaddr++];
        }
        return 0;
}

inline void dohdma(int line)
{
        int c,d;
        unsigned short indaddr;
        inhdma=1;
        for (c=0;c<8;c++)
        {
                if (!line)
                {
                        hdmaaddr[c]=dmasrc[c]&0xFFFF;
                        hdmabank[c]=dmasrc[c]>>16;
                        hdmacount[c]=0;
                }
                if (hdmaon & (1<<c))
                {
/*                        if (dmactrl[c]&0x40)
                        {
                                printf("Indirect HDMA on channel %i\n",c);
                                exit(-1);
                        }*/
                        if (!(hdmacount[c]&0x7F))
                        {
                                hdmacount[c]=readmem(hdmabank[c],hdmaaddr[c]++);
                                hdmarepeat[c]=hdmacount[c]&0x80;
                                hdmacount[c]&=0x7F;
                                switch (dmactrl[c]&0x47)
                                {
                                        case 0:
                                        hdmadata[c][0]=readmem(hdmabank[c],hdmaaddr[c]++);
                                        break;
                                        case 1:
                                        case 2:
                                        hdmadata[c][0]=readmem(hdmabank[c],hdmaaddr[c]++);
                                        hdmadata[c][1]=readmem(hdmabank[c],hdmaaddr[c]++);
                                        break;
                                        case 3:
                                        case 4:
                                        hdmadata[c][0]=readmem(hdmabank[c],hdmaaddr[c]++);
                                        hdmadata[c][1]=readmem(hdmabank[c],hdmaaddr[c]++);
                                        hdmadata[c][2]=readmem(hdmabank[c],hdmaaddr[c]++);
                                        hdmadata[c][3]=readmem(hdmabank[c],hdmaaddr[c]++);
                                        break;
                                        case 0x40:
                                        indaddr=readmem(hdmabank[c],hdmaaddr[c])|(readmem(hdmabank[c],hdmaaddr[c]+1)<<8); hdmaaddr[c]+=2;
                                        hdmadata[c][0]=readmem(dmabank[c],indaddr);
                                        break;
                                        case 0x41:
                                        case 0x42:
                                        indaddr=readmem(hdmabank[c],hdmaaddr[c])|(readmem(hdmabank[c],hdmaaddr[c]+1)<<8); hdmaaddr[c]+=2;                                        
                                        hdmadata[c][0]=readmem(dmabank[c],indaddr);
                                        hdmadata[c][1]=readmem(dmabank[c],indaddr+1);
                                        break;
                                        case 0x43:
                                        case 0x44:
                                        indaddr=readmem(hdmabank[c],hdmaaddr[c])|(readmem(hdmabank[c],hdmaaddr[c]+1)<<8); hdmaaddr[c]+=2;                                                                                
                                        hdmadata[c][0]=readmem(dmabank[c],indaddr);
                                        hdmadata[c][1]=readmem(dmabank[c],indaddr+1);
                                        hdmadata[c][2]=readmem(dmabank[c],indaddr+2);
                                        hdmadata[c][3]=readmem(dmabank[c],indaddr+3);
                                        break;
                                }
//                                printf("%i %i %02X
                                hdmafirst[c]=1;
                        }
                        if (hdmafirst[c] || hdmarepeat[c])
                        {
                                hdmafirst[c]=0;
                                switch (dmactrl[c]&7)
                                {
                                        case 0:
                                        writemem(0,0x2100|dmadest[c],hdmadata[c][0]);
                                        break;
                                        case 1:
                                        writemem(0,0x2100|dmadest[c],hdmadata[c][0]);
                                        writemem(0,0x2100|(dmadest[c]+1),hdmadata[c][1]);
                                        break;
                                        case 2:
                                        writemem(0,0x2100|dmadest[c],hdmadata[c][0]);
                                        writemem(0,0x2100|dmadest[c],hdmadata[c][1]);
                                        break;
                                        case 3:
                                        writemem(0,0x2100|dmadest[c],hdmadata[c][0]);
                                        writemem(0,0x2100|(dmadest[c]+1),hdmadata[c][1]);
                                        writemem(0,0x2100|dmadest[c],hdmadata[c][2]);
                                        writemem(0,0x2100|(dmadest[c]+1),hdmadata[c][3]);
                                        break;
                                        case 4:
                                        writemem(0,0x2100|dmadest[c],hdmadata[c][0]);
                                        writemem(0,0x2100|(dmadest[c]+1),hdmadata[c][1]);
                                        writemem(0,0x2100|(dmadest[c]+2),hdmadata[c][2]);
                                        writemem(0,0x2100|(dmadest[c]+3),hdmadata[c][3]);
                                        break;
                                }
                        }
                        hdmacount[c]--;
                }
        }
        inhdma=0;
        xs[0][line]=xscroll[0];
        ys[0][line]=yscroll[0];
        xs[1][line]=xscroll[1];
        ys[1][line]=yscroll[1];
        xs[2][line]=xscroll[2];
        ys[2][line]=yscroll[2];
        xs[3][line]=xscroll[3];
        ys[3][line]=yscroll[3];
        for (c=0;c<4;c++)
            bgs[c][line]=bgaddr[c];
        for (c=0;c<4;c++)
            chs[c][line]=chraddr[c];
        ppumodel[line]=ppumode&7;
        bgenablel[line]=bgenable;
        m7al[line]=m7a;
        m7cl[line]=m7c;
        m7xl[line]=m7x;
        m7yl[line]=m7y;
        if (m7write || !line)
        {
                m7change[line]=1;
                m7bl[line]=m7b;
                m7dl[line]=m7d;
        }
        else
           m7change[line]=0;
        m7write=0;
}

int sprx[128],spry[128],sprt[128],sprc[128],sprsx[128],sprsy[128],sprp[128],sprhf[128],sprvf[128];

void dumpspr()
{
        int c;
        FILE *f=fopen("sprites.txt","wt");
        char s[80];
        for (c=0;c<128;c++)
        {
                sprintf(s,"Sprite %02X : X %03i Y %03i T %03X P %i\n",c,sprx[c],spry[c],sprt[c],sprp[c]);
                fputs(s,f);
        }
        for (c=0;c<512;c+=4)
        {
                sprintf(s,"%02X %02X %02X %02X\n",objram[c],objram[c+1],objram[c+2],objram[c+3]);
                fputs(s,f);
        }
        fclose(f);
}

void decodesprites()
{
        int c;
        int addr=512-4;
        int sprsize;
        int addrtemp=543;
        int tempval,temppos=0;
        tempval=objram[addrtemp];
        for (c=127;c>=0;c--)
        {
                sprx[c]=objram[c<<2];
                if (tempval&0x40) sprx[c]|=256;
                sprx[c]+=8;
                sprx[c]&=511;
                spry[c]=objram[(c<<2)+1]+1;
                sprt[c]=objram[(c<<2)+2]|((objram[(c<<2)+3]&1)<<8);
                sprc[c]=(coltable[(objram[(c<<2)+3]>>1)&7]|0x08080808)<<4;
                sprp[c]=(objram[(c<<2)+3]>>4)&3;
                sprhf[c]=(objram[(c<<2)+3]&0x40)?1:0;
                sprvf[c]=(objram[(c<<2)+3]&0x80)?1:0;
                sprsize=tempval&0x80;
                if (sprsize)
                {
                        sprsx[c]=objsize[2];
                        sprsy[c]=objsize[3];
                }
                else
                {
                        sprsx[c]=objsize[0];
                        sprsy[c]=objsize[1];
                }
                tempval<<=2;
                temppos++;
                if (temppos==4)
                {
                        addrtemp--;
                        tempval=objram[addrtemp];
                }
                temppos&=3;
//                printf("%03i %03i %03i %03i %03i %03i\n",c,sprp[c],sprx[c],spry[c],sprsx[c],sprsy[c]);
        }
//        printf("\n");
}

void drawsprites(int pri)
{
        int c;
        int x,y,yy,yf,ys,ye,yd;
        unsigned long *p;
        unsigned short temp,temps;
        unsigned char datm,dat1,dat2,dat3,dat4;
        int sx,ex,dx,dt,ox,oy;
        char s[3]={0,0,0};
        for (c=127;c>=0;c--)
        {
                if (pri==sprp[c] && (sprx[c]>448 || sprx[c]<320) && (spry[c]>448 || spry[c]<288))
                {
//                        sprintf(s,"%02X",c);
//                        ox=sprx[c];
//                        oy=spry[c];
                        if (!sprhf[c])
                        {
                                sx=0;
                                ex=sprsx[c]<<3;
                                dx=8;
                                dt=16;
                                temps=((sprt[c]&511)<<5)+sprchraddr;
                        }
                        else
                        {
                                sx=(sprsx[c]<<3)-8;
                                ex=-8;
                                dx=-8;
                                dt=-48;
                                temps=((((sprt[c]+sprsx[c])-1)&511)<<5)+sprchraddr;
                        }
                        if (!sprvf[c])
                        {
                                ys=0;
                                ye=8;
                                yd=1;
                        }
                        else
                        {
                                ys=7;
                                ye=-1;
                                yd=-1;
                        }
                        yf=(sprsy[c]<<3)-1;
                        for (y=0;y<sprsy[c]<<3;y+=8)
                        {
                                if (sprvf[c]) temp=temps+(((y^yf)&~7)<<6);
                                else          temp=temps+(y<<6);
                                for (x=0;x!=sprsx[c]<<3;x+=8)
                                {
                                        for (yy=ys;yy!=ye;yy+=yd)
                                        {
                                                if ((spry[c]+yy+y)>-1 && (spry[c]+yy+y)<224)
                                                {
                                                        p=(unsigned long *)(b->line[spry[c]+yy+y]+sprx[c]+x);
                                                        dat1=vram[temp];
                                                        dat2=vram[temp+1];
                                                        dat3=vram[temp+16];
                                                        dat4=vram[temp+17];
                                                        datm=dat1|dat2|dat3|dat4;
                                                        p[0^sprhf[c]]&=~masktable[sprhf[c]][datm>>4];
                                                        p[0^sprhf[c]]|=bittable[sprhf[c]][dat1>>4]|(bittable[sprhf[c]][dat2>>4]<<1)|(bittable[sprhf[c]][dat3>>4]<<2)|(bittable[sprhf[c]][dat4>>4]<<3)|(sprc[c]&masktable[sprhf[c]][datm>>4]);
                                                        p[1^sprhf[c]]&=~masktable[sprhf[c]][datm&0xF];
                                                        p[1^sprhf[c]]|=bittable[sprhf[c]][dat1&0xF]|(bittable[sprhf[c]][dat2&0xF]<<1)|(bittable[sprhf[c]][dat3&0xF]<<2)|(bittable[sprhf[c]][dat4&0xF]<<3)|(sprc[c]&masktable[sprhf[c]][datm&0xF]);
                                                }
                                                temp+=2;
                                        }
                                        temp+=dt;
                                }
//                                textout(b,font,s,ox,oy,makecol(255,255,255));
                        }
                }
        }
}

int bpptable[8][4]=
{
        {2,2,2,2},
        {4,4,2,0},
        {4,4,0,0},
        {8,4,0,0},
        {8,2,0,0},
        {4,2,0,0},
        {4,0,0,0},
        {7,0,0,0}
};

#define getm7pixel(x,y) temp=vram[(((y&~7)<<5)|((x&~7)>>2))&0xFFFF]; col=vram[((temp<<7)+((y&7)<<4)+((x&7)<<1)+1)&0xFFFF]
int firstbg[256];

void drawlayer(int layer, int pri, int hipri)
{
        int x,xx,xxx,y,yy,yyy,yyyy,line,linee,xmask,lt;
        unsigned char dat1,dat2,dat3,dat4,dat5,dat6,dat7,dat8,datm,*cp;
        unsigned short temp,temp2,baddr,m7bb,m7dd;
        unsigned long col,*p;
        unsigned long aa=0,bb,cc=0,dd;
        unsigned int m7xx=(m7x<<19)>>19,m7yy=(m7y<<19)>>19;
        union
        {
                struct
                {
                        unsigned char a,b,c,d;
                } b;
                struct
                {
                        unsigned short a,b;
                } w;
                unsigned long l;
        } data;
        pri=(pri)?0x2000:0;
        m7bb=m7b;
        m7dd=m7d;
        for (linee=0;linee<224;linee++)
        {
                line=linee;
                if (ppumodel[line]==1 && bg3pri && pri && !hipri && layer==3) continue;
                if (ppumodel[line]==1 && !bg3pri && pri && hipri && layer==3) continue;
                if (!bpptable[ppumodel[line]][layer] || !(bgenablel[line]&(1<<layer))) continue;
                if (firstbg[line]) { memset(b->line[line],0,256); firstbg[line]=0; }
                lt=(tilesize&(1<<layer))?4:0;
//                if (mosaic && (mosaicen&(1<<layer))) line-=(linee%mosaic);
                y=ys[layer][line]+line;
                yy=y&7;
                xxx=xs[layer][line]&7;
                switch (bgsize[layer]|lt)
                {
                        case 0: y&=255; baddr=((bgs[layer][line]>>1)+((y>>3)<<5))&0x7FFF; x=(xs[layer][line]>>3)&31; xmask=0x3F; break;
                        case 1: y&=255; baddr=((bgs[layer][line]>>1)+((y>>3)<<5))&0x7FFF; x=(xs[layer][line]>>3); x=(x&32)?((x&31)|0x400):x&31; xmask=0x43F; break;
                        case 2: y&=511; baddr=(((bgs[layer][line]>>1)+(((y&255)>>3)<<5))+((y&256)<<2))&0x7FFF; x=(xs[layer][line]>>3)&31; xmask=0x3F; break;
                        case 3: y&=511; baddr=(((bgs[layer][line]>>1)+(((y&255)>>3)<<5))+((y&256)<<3))&0x7FFF; x=(xs[layer][line]>>3); x=(x&32)?((x&31)|0x400):x&31; xmask=0x43F; break;
                        /*16x16 tile stuff*/
                        case 4: y&=255; baddr=((bgs[layer][line]>>1)+((y>>4)<<5))&0x7FFF; x=(xs[layer][line]>>3)&31; xmask=0x3F; break;
                        case 5: y&=255; baddr=((bgs[layer][line]>>1)+((y>>4)<<5))&0x7FFF; x=(xs[layer][line]>>3); x=(x&32)?((x&31)|0x400):x&31; xmask=0x43F; break;
                        case 6: y&=511; baddr=(((bgs[layer][line]>>1)+(((y&255)>>4)<<5))+((y&256)<<2))&0x7FFF; x=(xs[layer][line]>>3)&31; xmask=0x3F; break;
                        case 7: y&=511; baddr=(((bgs[layer][line]>>1)+(((y&255)>>4)<<5))+((y&256)<<3))&0x7FFF; x=(xs[layer][line]>>3); x=(x&32)?((x&31)|0x400):x&31; xmask=0x43F; break;
                }
                p=(unsigned long *)((b->line[line]-xxx)+8);
                cp=(unsigned char *)p;
                switch (bpptable[ppumodel[line]][layer])
                {
                        case 2:
                        for (xx=0;xx<33;xx++)
                        {
                                if (lt) temp2=((short *)vram)[baddr+((x>>1)&xmask)];
                                else    temp2=((short *)vram)[baddr+(x&xmask)];
                                if ((temp2&0x2000)==pri)
                                {
                                        col=coltable[(temp2>>10)&7]<<2;
                                        if (temp2&0x8000) temp=((temp2&1023)<<4)+chs[layer][line]+((yy^7)<<1);
                                        else              temp=((temp2&1023)<<4)+chs[layer][line]+(yy<<1);
                                        if (lt && (x&1)) temp+=16;
                                        if (lt && (y&8)) temp+=256;
                                        if (temp2&0x4000)
                                        {
                                                data.b.a=fliptable[vram[temp]];
                                                data.b.b=fliptable[vram[temp+1]];
                                        }
                                        else
                                        {
                                                data.w.a=((unsigned short *)vram)[temp>>1];
                                        }
                                        datm=data.b.a|data.b.b;
                                        if (data.w.a)
                                        {
                                                p[xx<<1]&=~masktable[0][datm>>4];
                                                p[xx<<1]|=bittable[0][data.b.a>>4]|(bittable[0][data.b.b>>4]<<1)|(col&masktable[0][datm>>4]);
                                                p[(xx<<1)+1]&=~masktable[0][datm&0xF];
                                                p[(xx<<1)+1]|=bittable[0][data.b.a&0xF]|(bittable[0][data.b.b&0xF]<<1)|(col&masktable[0][datm&0xF]);
                                        }
/*                                        if (temp2&0x4000)
                                        {
                                                dat1=fliptable[vram[temp]];
                                                dat2=fliptable[vram[temp+1]];
                                        }
                                        else
                                        {
                                                dat1=vram[temp];
                                                dat2=vram[temp+1];
                                        }
                                        if (datm=(dat1|dat2))
                                        {
                                                p[xx<<1]&=~masktable[0][datm>>4];
                                                p[xx<<1]|=bittable[0][dat1>>4]|(bittable[0][dat2>>4]<<1)|(col&masktable[0][datm>>4]);
                                                p[(xx<<1)+1]&=~masktable[0][datm&0xF];
                                                p[(xx<<1)+1]|=bittable[0][dat1&0xF]|(bittable[0][dat2&0xF]<<1)|(col&masktable[0][datm&0xF]);
                                        }*/
                                        x++;
                                        if (x==0x420) x=0;
                                        if (x==32) x=0x400;
                                }
                        }
                        break;

                        case 4:
                        for (xx=0;xx<33;xx++)
                        {
                                if (lt) temp2=((short *)vram)[baddr+((x>>1)&xmask)];
                                else    temp2=((short *)vram)[baddr+(x&xmask)];
                                if ((temp2&0x2000)==pri)
                                {
                                        col=coltable[(temp2>>10)&7]<<4;
                                        if (temp2&0x8000) temp=((temp2&1023)<<5)+chs[layer][line]+((yy^7)<<1);
                                        else              temp=((temp2&1023)<<5)+chs[layer][line]+(yy<<1);
                                        if (lt && (x&1)) temp+=32;
                                        if (lt && (y&8)) temp+=512;                                        
                                        if (temp2&0x4000)
                                        {
                                                data.b.a=fliptable[vram[temp]];
                                                data.b.b=fliptable[vram[temp+1]];
                                                data.b.c=fliptable[vram[temp+16]];
                                                data.b.d=fliptable[vram[temp+17]];
                                        }
                                        else
                                        {
                                                data.w.a=((unsigned short *)vram)[temp>>1];
                                                data.w.b=((unsigned short *)vram)[(temp+16)>>1];                                                
                                        }
                                        datm=data.b.a|data.b.b|data.b.c|data.b.d;
                                        if (data.l)
                                        {
                                                p[xx<<1]&=~masktable[0][datm>>4];
                                                p[xx<<1]|=bittable[0][data.b.a>>4]|(bittable[0][data.b.b>>4]<<1)|(bittable[0][data.b.c>>4]<<2)|(bittable[0][data.b.d>>4]<<3)|(col&masktable[0][datm>>4]);
                                                p[(xx<<1)+1]&=~masktable[0][datm&0xF];
                                                p[(xx<<1)+1]|=bittable[0][data.b.a&0xF]|(bittable[0][data.b.b&0xF]<<1)|(bittable[0][data.b.c&0xF]<<2)|(bittable[0][data.b.d&0xF]<<3)|(col&masktable[0][datm&0xF]);
                                        }
                                }
                                x++;
                                if (x==0x420) x=0;
                                if (x==32) x=0x400;
                        }
                        break;

                        case 7:
                        if (!line || m7change[line])
                        {
                                bb=((signed short)m7bb*(-m7yl[line]))+(m7xl[line]<<8);
                                dd=((signed short)m7dd*(-m7yl[line]))+(m7yl[line]<<8);
                                if (line)
                                {
                                        m7bb=m7bl[line];
                                        m7dd=m7dl[line];
                                }
                        }
                        aa=((signed short)m7al[line]*(-m7xl[line]));
                        cc=((signed short)m7cl[line]*(-m7xl[line]));
                        for (x=0;x<256;x++)
                        {
                                xx=((xs[0][line]&1023)+((aa+bb)>>8))&1023;
                                yy=((ys[0][line]&1023)+((cc+dd)>>8))&1023;
                                xxx=((((xs[0][line]+x)&1023)-x)&1023)+((aa+bb)>>8);
                                yyy=((((ys[0][line]+x)&1023)-x)&1023)+((cc+dd)>>8);
                                if ( (!((xxx|yyy)&0xFFC00)) || !(m7sel&0xC0))
                                {
                                        getm7pixel(xx,yy);
                                        if (col) *cp=col;
                                }
                                else if ((m7sel&0xC0)==0x80)
                                {                        
                                        col=vram[((temp<<7)+((yy&7)<<4)+((xx&7)<<1)+1)&0x7FFF];
                                        if (col) *cp=col;
                                }
                                aa+=(signed short)m7al[line];
                                cc+=(signed short)m7cl[line];
                                cp++;
                        }
                        bb+=((signed short)m7bb);
                        dd+=((signed short)m7dd);
                        break;
                        
                        case 8:
                        for (xx=0;xx<33;xx++)
                        {
                                temp2=((short *)vram)[baddr+(x&xmask)];
                                if ((temp2&0x2000)==pri)
                                {
                                        if (temp2&0x8000) temp=((temp2&1023)<<6)+chs[layer][line]+((yy^7)<<1);
                                        else              temp=((temp2&1023)<<6)+chs[layer][line]+(yy<<1);
                                        if (temp2&0x4000)
                                        {
                                                dat1=fliptable[vram[temp]];
                                                dat2=fliptable[vram[temp+1]];
                                                dat3=fliptable[vram[temp+16]];
                                                dat4=fliptable[vram[temp+17]];
                                                dat5=fliptable[vram[temp+32]];
                                                dat6=fliptable[vram[temp+33]];
                                                dat7=fliptable[vram[temp+48]];
                                                dat8=fliptable[vram[temp+49]];
                                        }
                                        else
                                        {
                                                dat1=vram[temp];
                                                dat2=vram[temp+1];
                                                dat3=vram[temp+16];
                                                dat4=vram[temp+17];
                                                dat5=vram[temp+32];
                                                dat6=vram[temp+33];
                                                dat7=vram[temp+48];
                                                dat8=vram[temp+49];
                                        }
                                        if (datm=(dat1|dat2|dat3|dat4|dat5|dat6|dat7|dat8))
                                        {
                                                p[(xx+1)<<1]&=~masktable[0][datm>>4];
                                                p[(xx+1)<<1]|=bittable[0][dat1>>4]|(bittable[0][dat2>>4]<<1)|(bittable[0][dat3>>4]<<2)|(bittable[0][dat4>>4]<<3)|(bittable[0][dat5>>4]<<4)|(bittable[0][dat6>>4]<<5)|(bittable[0][dat7>>4]<<6)|(bittable[0][dat8>>4]<<7);
                                                p[((xx+1)<<1)+1]&=~masktable[0][datm&0xF];
                                                p[((xx+1)<<1)+1]|=bittable[0][dat1&0xF]|(bittable[0][dat2&0xF]<<1)|(bittable[0][dat3&0xF]<<2)|(bittable[0][dat4&0xF]<<3)|(bittable[0][dat5&0xF]<<4)|(bittable[0][dat6&0xF]<<5)|(bittable[0][dat7&0xF]<<6)|(bittable[0][dat8&0xF]<<7);
                                        }
                                }
                                x++;
                                if (x==0x420) x=0;
                                if (x==32) x=0x400;
                        }
                        break;
                }
        }
}

void drawthescreen(int line)
{
        int y,yy,x,xx,xxx;
        int c;
        int xmask;
        unsigned short baddr,temp,temp2;
        unsigned long templ;
        int col;
        int maskit=0;
        unsigned char dat1,dat2,dat3,dat4,tempc;
        clear(b);
        if (!screenon)
           return;
        decodesprites();
        if (bgenable==0x10)
        {
                drawsprites(0);
                drawsprites(1);
                drawsprites(2);
                drawsprites(3);
                return;
        }
        memset(firstbg,0,sizeof(firstbg));
        drawlayer(3,0,0);
        drawlayer(2,0,0);
        drawsprites(0);
        drawlayer(3,1,0);
        drawlayer(2,1,0);
        drawsprites(1);
        drawlayer(1,0,0);
        drawlayer(0,0,0);
        drawsprites(2);
        drawlayer(1,1,0);
        drawlayer(0,1,0);
//        drawsprites(0);
//        drawsprites(1);
//        drawsprites(2);                        
        drawsprites(3);
        drawlayer(2,1,1);
/*        switch (ppumode)
        {
                case 0:
                maskit=0;
                if (bgenable&8)
                {
                        drawm(3,maskit,0,2);
                        maskit=1;
                }
                if (bgenable&4)
                {
                        drawm(2,maskit,0,2);
                        maskit=1;
                }
                drawsprites(0);
                if (bgenable&8)
                {
                        drawm(3,maskit,1,2);
                        maskit=1;
                }
                if (bgenable&4)
                {
                        drawm(2,maskit,1,2);
                        maskit=1;
                }
                drawsprites(1);
                if (bgenable&2)
                {
                        drawm(1,maskit,0,2);
                        maskit=1;
                }
                if (bgenable&1)
                {
                        drawm(0,maskit,0,2);
                        maskit=1;
                }
                drawsprites(2);
                if (bgenable&2)
                {
                        drawm(1,maskit,1,2);
                        maskit=1;
                }
                if (bgenable&1)
                {
                        drawm(0,maskit,1,2);
                        maskit=1;
                }
                drawsprites(3);
                break;

                case 1:
                maskit=0;
                if (bgenable&4)
                {
                        drawm(2,maskit,0,2);
                        maskit=1;
                }
                drawsprites(0);
                if (bgenable&4 && !bg3pri)
                {
                        drawm(2,maskit,1,2);
                        maskit=1;
                }
                drawsprites(1);
                if (bgenable&2)
                {
                        drawm(1,maskit,0,4);
                        maskit=1;
                }
                if (bgenable&1)
                {
                        drawm(0,maskit,0,4);
                        maskit=1;
                }
                drawsprites(2);
                if (bgenable&2)
                {
                        drawm(1,maskit,1,4);
                        maskit=1;
                }
                if (bgenable&1)
                {
                        drawm(0,maskit,1,4);
                        maskit=1;
                }
                drawsprites(3);
                if (bgenable&4 && bg3pri)
                {
                        drawm(2,maskit,1,2);
                        maskit=1;
                }
                break;

                case 2:
                maskit=0;
                if (bgenable&2)
                {
                        drawm1(1,maskit,0);
                        maskit=1;
                }
                drawsprites(0);
                drawsprites(1);
                if (bgenable&1)
                {
                        drawm1(0,maskit,0);
                        maskit=1;
                }
                drawsprites(2);
                if (bgenable&2)
                {
                        drawm1(1,maskit,1);
                        maskit=1;
                }
                if (bgenable&1)
                {
                        drawm1(0,maskit,1);
                        maskit=1;
                }
                drawsprites(3);
                break;

                case 3:
                maskit=0;
                if (bgenable&2)
                {
                        drawm1(1,maskit,0);
                        maskit=1;
                }
                if (bgenable&1)
                {
                        drawm3(0,maskit,0);
                        maskit=1;
                }
                drawsprites(0);
                drawsprites(1);
                if (bgenable&2)
                {
                        drawm1(1,maskit,1);
                        maskit=1;
                }
                if (bgenable&1)
                {
                        drawm3(0,maskit,1);
                        maskit=1;
                }
                drawsprites(2);
                drawsprites(3);
                break;
                
                case 4:
                clear(b);
                textout(b,font,"Mode 4 not emulated",0,0,makecol(255,255,255));
                break;
                case 5:
                clear(b);
                textout(b,font,"Mode 5 not emulated",0,0,makecol(255,255,255));
                break;
                case 6:
                clear(b);
                textout(b,font,"Mode 6 not emulated",0,0,makecol(255,255,255));
                break;
                case 7:
                clear(b);
                drawsprites(0);
                drawsprites(1);
                drawm7(0);
                drawsprites(2);
                drawsprites(3);
                break;
        }*/
}                                

void blitthescreen()                       
{
        int x,y;
        unsigned short baddr;
        char s[80];
//        dosprites();
        showspc();
        blit(b,screen,8,0,32,8,256,224);
        sprintf(s,"%i    ",fps);
        textout(screen,font,s,0,0,makecol(255,255,255));
        frames++;
        for (x=0;x<256;x++)
        {
                if (paldirty[x]) set_color(x,&pal[x]);
                paldirty[x]=0;
        }
//        if (!key[KEY_0]) vsync();
}
